﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.ComponentModel.DataAnnotations;
using ITProject.Domain.Entities;

namespace ITProject.WebUI.Models.ProjectAdmin
{
    public class ProjectAdminChangeTaskStatusViewModel
    {
        public List<SelectListItem> StatusList { get; set; }
        [Required(ErrorMessage = "Musisz wybrać status")]
        [Display(Name = "Nowy status zadania")]
        public string ReturnStatus { get; set; }
        [Display(Name = "Nazwa zadania")]
        public string TaskName { get; set; }
        [Display(Name = "Komentarz do zmiany statusu zadania")]
        public string Comment { get; set; }

        // ukryte
        public int TaskId { get; set; }
        public string ProjectName { get; set; }

        public static ProjectAdminChangeTaskStatusViewModel Convert(Task task, string projectName)
        {
            ProjectAdminChangeTaskStatusViewModel vm = new ProjectAdminChangeTaskStatusViewModel();
            vm.ProjectName = projectName;
            vm.TaskId = task.Id;
            vm.TaskName = task.Name;
            vm.StatusList = new List<SelectListItem>();
            SelectListItem actualStatus = new SelectListItem { Selected = true, Text = StatusName.ConvertFromByte(task.Status) };
            vm.StatusList.Add(actualStatus);
            if (StatusName.ConvertFromByte(task.Status) != StatusName.Active)
            {
                SelectListItem status1 = new SelectListItem { Text = StatusName.Active };
                vm.StatusList.Add(status1);
            }
            if (StatusName.ConvertFromByte(task.Status) != StatusName.Planned)
            {
                SelectListItem status1 = new SelectListItem { Text = StatusName.Planned };
                vm.StatusList.Add(status1);
            }
            if (StatusName.ConvertFromByte(task.Status) != StatusName.Done)
            {
                SelectListItem status1 = new SelectListItem { Text = StatusName.Done };
                vm.StatusList.Add(status1);
            }
            if (StatusName.ConvertFromByte(task.Status) != StatusName.Tested)
            {
                SelectListItem status1 = new SelectListItem { Text = StatusName.Tested };
                vm.StatusList.Add(status1);
            }
            if (StatusName.ConvertFromByte(task.Status) != StatusName.Accepted)
            {
                SelectListItem status1 = new SelectListItem { Text = StatusName.Accepted };
                vm.StatusList.Add(status1);
            }
            return vm;
        }

        public static StatusChange Convert(ProjectAdminChangeTaskStatusViewModel vm, Task task, int userId)
        {
            StatusChange sc = new StatusChange();
            sc.Comment = vm.Comment;
            sc.DateOfChange = DateTime.Now;
            sc.NewStatus = (byte)StatusName.ConvertFromString(vm.ReturnStatus);
            sc.OldStatus = task.Status;
            sc.UserId = userId;
            return sc;
        }
    }
}