﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using ITProject.Domain.Entities;

namespace ITProject.WebUI.Models.ProjectUser
{
    public class ProjectUserChangeMyFeatureStatusViewModel
    {
        [Display(Name="Nazwa funkcjonalności")]
        public string Name { get; set; }
        public List<SelectListItem> StatusList { get; set; }
        [Display(Name = "Nowy status funkcjonalności")]
        [Required(ErrorMessage="Musisz podać nowy status")]
        public string ReturnStatus { get; set; }
        [Display(Name = "Komentarz zmiany statusu")]
        public string Comment { get; set; }

        // ukryte
        public string ProjectName { get; set; }
        public int FeatureId { get; set; }

        public static void CompleteStatusList(ProjectUserChangeMyFeatureStatusViewModel vm, byte status)
        {
            string actualStatus = StatusName.ConvertFromByte(status);
            SelectListItem actualStatusItem = new SelectListItem { Selected = true, Text = actualStatus };
            vm.StatusList.Add(actualStatusItem);
            if (actualStatus != StatusName.Planned)
                vm.StatusList.Add(new SelectListItem { Selected = false, Text = StatusName.Planned });
            if (actualStatus != StatusName.Active)
                vm.StatusList.Add(new SelectListItem { Selected = false, Text = StatusName.Active });
            if (actualStatus != StatusName.Done)
                vm.StatusList.Add(new SelectListItem { Selected = false, Text = StatusName.Done });
            if (actualStatus != StatusName.Tested)
                vm.StatusList.Add(new SelectListItem { Selected = false, Text = StatusName.Tested });
        }

        public static ProjectUserChangeMyFeatureStatusViewModel Convert(Feature feature, string projectName)
        {
            ProjectUserChangeMyFeatureStatusViewModel vm = new ProjectUserChangeMyFeatureStatusViewModel();
            vm.ProjectName=projectName;
            vm.FeatureId=feature.Id;
            vm.Name = feature.Name;
            vm.StatusList = new List<SelectListItem>();
            CompleteStatusList(vm,feature.Status);
            return vm;
        }

        public static StatusChange Convert(ProjectUserChangeMyFeatureStatusViewModel vm, byte oldStatus,int userId)
        {
            StatusChange sc = new StatusChange();
            sc.Comment = vm.Comment;
            sc.DateOfChange = DateTime.Now;
            sc.NewStatus = (byte)StatusName.ConvertFromString(vm.ReturnStatus);
            sc.OldStatus = oldStatus;
            sc.UserId = userId;
            return sc;
        }
    }
}