﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using ITProject.Domain.Entities;

namespace ITProject.WebUI.Models.ProjectUser
{
    public class ProjectUserMyTaskViewModel
    {
        [Display(Name = "Nazwa")]
        public string Name { get; set; }
        [Display(Name = "Status")]
        public string Status { get; set; }
        [Display(Name = "Priorytet")]
        public string Priority { get; set; }
        [Display(Name = "Planowana data zakończenia")]
        public string PlannedEndDate { get; set; }

        // ukryte
        public int TaskId { get; set; }

        public static ProjectUserMyTaskViewModel[] Convert(Task[] tasks)
        {
            ProjectUserMyTaskViewModel[] vmTab = new ProjectUserMyTaskViewModel[tasks.Length];
            for (int i = 0; i < vmTab.Length; i++)
            {
                vmTab[i] = new ProjectUserMyTaskViewModel();
                vmTab[i].Name = tasks[i].Name;
                vmTab[i].TaskId = tasks[i].Id;
                vmTab[i].PlannedEndDate = tasks[i].PlannedStopDate.ToLongDateString();
                vmTab[i].Status = StatusName.ConvertFromByte(tasks[i].Status);
                vmTab[i].Priority = PriorityViewModel.ConvertFromByte(tasks[i].Priority);
            }
            return vmTab;
        }
    }
}